<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: clase_entidad.php
// Tipo: definicion de clase
// Desarrolladores: Juanan Ruiz (juanan@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: gestiona las entidades 
//---------------------------------------------------------------------------------------------------

class entidad {
   //Propiedades de la clase
   var $id_entidad;
   var $nombre; 
   var $base_datos; //objeto de conexion a la base de datos
   var $error; //propiedad de uso interno para almacenar los errores
   
   // Metodos de la clase
   function entidad($base_datos) {
      $this->base_datos = $base_datos;
      }
      
   function obtener_datos($id_entidad) {
      //Obtiene los datos de la entidad 
      $consulta = "SELECT * FROM entidad WHERE id_entidad=" . $id_entidad;
      $this->base_datos->ejecutar_consulta($consulta);
      if ($this->base_datos->filas_implicadas > 0) {
         $this->base_datos->obtener_fila();
         $this->id_entidad = $this->base_datos->fila["id_entidad"];
         $this->nombre = $this->base_datos->fila["nombre"];
         return TRUE;
         }
      else {
	 $this->error = "El nombre de la entidad ya existe en el sistema";
	 return FALSE;
	 }
      }
   
   function crear ($nombre) {
      //Primero compruebo que no exista otra entidad con el mismo nombre en la base de datos
      $consulta = "SELECT * FROM entidad WHERE nombre = '" . $nombre  . "'";
      $this->base_datos->ejecutar_consulta($consulta);
      //echo $consulta;
      if ($this->base_datos->filas_implicadas == 0) {
         //Si la consulta no devuelve ninguna fila el nombre no existe en la base de datos y podemos grabar la nueva entidad
	 $consulta = "INSERT INTO entidad (nombre) VALUES ('" . $nombre ."')";
	 $this->base_datos->ejecutar_consulta($consulta);
	 $this->id_entidad = $this->base_datos->obtener_ultima_id();
	 if ($this->obtener_datos($this->id_entidad)) 
	    return TRUE;
	 else {
	    $this->error = "Error desconocido. No se ha podido grabar la entidad en la base de datos";
	    return FALSE;
            }
	 	 }
      else {
         //Si la consulta devuelve alguna fila el nombre ya existe y no grabamos
         $this->error = "ERROR: El nombre de entidad '" . $nombre  . "' ya existe en el sistema";
	 return FALSE;
         }
      }	   
     
   function listar_indicadores(){
      //Devuelve los indicadores existentes para esta entidad
      $consulta = "SELECT *, indicador.nombre as nombre_indicador, usuario.nombre as nombre_usuario FROM indicador";
      $consulta .= " INNER JOIN usuario ON indicador.id_responsable = usuario.id_usuario WHERE id_entidad=" . $this->id_entidad;
      $consulta .= " ORDER BY nombre_indicador ASC";		 
      //Devuelve un array con las filas devueltas por la base de datos
      $this->base_datos->ejecutar_consulta($consulta);
      $fila = 0;
      while ($this->base_datos->obtener_fila()) {
	    $lista_indicadores[$fila] = $this->base_datos->fila;
	    $fila ++;
	    }   
      return $lista_indicadores;
   }
   
   function listar_usuarios() {
      // Realiza una lista de usuarios de una entidad, si no hay entidad los devuelve todos
      $lista_usuarios = array();
      $consulta = "SELECT u.id_usuario as id_usuario, u.nombre as nombre, u.apellidos as apellidos, u.login as login, ";
      $consulta .= "u.correo as correo, ue.rol as rol";
      $consulta .= " FROM usuario u";
      $consulta .= " INNER JOIN usuario_entidad ue ON u.id_usuario = ue.id_usuario  WHERE ue.id_entidad=" . $this->id_entidad;
      $consulta .= " ORDER BY u.login";
      //:echo $consulta; //debug
      $this->base_datos->ejecutar_consulta($consulta);
      while ($this->base_datos->obtener_fila()) {
	    $lista_usuarios[] = $this->base_datos->fila;
	    }   
      return $lista_usuarios;
      }
      
}
?>
