<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: clase_indicador.php
// Tipo: definicion de clase
// Desarrolladores: Juanan Ruiz (juanan@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: Gestiona los indicadores 
//---------------------------------------------------------------------------------------------------

class indicador {
   //----------------------------------------------------------------
   //Propiedades de la clase
   //----------------------------------------------------------------
   //Parametros del indicador 
   var $id_indicador;
   var $id_entidad;
   var $nombre;
   var $descripcion;
   var $formulacion;
   var $fuente;
   var $umbral;
   var $periodicidad;
   var $id_responsable;
   var $login_responsable;
   var $nombre_responsable;
   var $apellidos_responsable;
   var $valores = array();
   
   var $base_datos;
   
   var $error; //recoge los errores internos, solo sirve para debug
   var $nombre_duplicado; //se pone a true si se intenta grabar un indicador con nombre repetido para la misma entidad TODO: eliminar?
   
   //----------------------------------------------------------------
   //Metodos de la clase
   //----------------------------------------------------------------

   function indicador ($base_datos) {
      	$this->base_datos = $base_datos;
   	}
   
   //Graba un nuevo indicador en la base de datos comprobando duplicados
   function crear ($nombre,$umbral,$id_entidad,$descripcion,$formulacion,$fuente,$periodicidad,$id_responsable) {
      //Comprueba que el nombre del indicador no este duplicado para esta entidad
      $consulta = "SELECT nombre FROM indicador WHERE nombre='" . $nombre  . "' AND id_entidad=". $id_entidad;
      $this->base_datos->ejecutar_consulta($consulta); 
      //Si la consulta viene llena devuelve un error
      if ($this->base_datos->obtener_fila()) {
            $this->nombre_duplicado = TRUE;
            return FALSE;
	    }	 
      else 
	    $this->nombre_duplicado = FALSE;
	 
      //Ahora ya puedo grabar en la base de datos
      $consulta = "INSERT INTO indicador (nombre,umbral,id_entidad,descripcion,formulacion,fuente,periodicidad,id_responsable) ";
      $consulta .= "VALUES ('".$nombre."','".$umbral."',".$id_entidad.",'".$descripcion."','".$formulacion."','".$fuente."','".$periodicidad."',".$id_responsable.")";
      $this->base_datos->ejecutar_consulta($consulta); 
      $this->id_indicador = $this->base_datos->obtener_ultima_id();
      return TRUE;
   }	   
   
   function obtener_datos($id_indicador){
      $datos = array();
      $consulta = "SELECT id_indicador, id_entidad, i.nombre as nombre, descripcion, formulacion, fuente, umbral, periodicidad, i.id_responsable as id_responsable, ";
      $consulta .= "u.nombre as nombre_responsable, apellidos, login ";
      $consulta .= "FROM indicador i INNER JOIN usuario u ON i.id_responsable = u.id_usuario WHERE id_indicador=" . $id_indicador;
      $this->base_datos->ejecutar_consulta($consulta);
      if ($this->base_datos->filas_implicadas > 0) {
      	$this->base_datos->obtener_fila();
	$datos = $this->base_datos->fila;
	$this->id_indicador = $datos["id_indicador"];
	$this->id_entidad = $datos["id_identidad"];
	$this->nombre = $datos["nombre"];	
	$this->descripcion = $datos["descripcion"];	
	$this->formulacion = $datos["formulacion"];	
	$this->fuente = $datos["fuente"];
	$this->umbral = $datos["umbral"];
	$this->periodicidad = $datos["periodicidad"];
	$this->id_responsable = $datos["id_responsable"];
	$this->nombre_responsable = $datos["nombre_responsable"];
	$this->apellidos_responsable = $datos["apellidos"];
	$this->login_responsable = $datos["login"];
	
	return true;
	
	}   
      else {
      	$this->error = "ERROR: No se encuentra ningun indicador con este identificador";
        return false;
	}
   }
   
   function actualizar_datos($id_indicador,$nombre,$umbral,$id_entidad,$descripcion,$formulacion,$fuente,$periodicidad,$id_responsable) {
      $consulta = "UPDATE indicador SET ";
      $consulta .= "nombre='" . $nombre . "',";
      $consulta .= "descripcion='" . $descripcion . "',";
      $consulta .= "fuente='" . $fuente . "',";
      $consulta .= "formulacion='" . $formulacion . "',";
      $consulta .= "periodicidad='" . $periodicidad . "',";
      $consulta .= "umbral='" . $umbral . "',";
      $consulta .= "id_entidad=" . $id_entidad . ",";
      $consulta .= "id_responsable=" . $id_responsable . " ";
      $consulta .= "WHERE id_indicador = " . $id_indicador;
      if ($this->base_datos->ejecutar_consulta($consulta)) {
         return true;
	 }
      else {
	 $this->error = "ERROR: No se ha podido actualizar el indicador";
         return false;
	 }
      }


	function listar_valores($id_indicador) {
		$consulta = "SELECT id_valor, valor, periodo, fecha_recogida FROM valor WHERE indicador = " . $id_indicador . " ORDER BY fecha_recogida";
		$this->base_datos->ejecutar_consulta($consulta);
 		if ($this->base_datos->filas_implicadas > 0) {
		      	while ($this->base_datos->obtener_fila()) {
				$datos = $this->base_datos->fila;
				// Convierte la fecha de sql a formato espanol
				$fecha_recogida = $this->base_datos->fecha_sql_es($datos["fecha_recogida"]);
				// Rellena el array con los valores
				$this->valores[$datos["id_valor"]] = array("id_valor"=>$datos["id_valor"],"dato"=> $datos["valor"],
					"periodo"=> $datos["periodo"],"fecha_recogida"=>$fecha_recogida);
				}
			return true;
		}
		else
			return false;
	
	}
	
}      
?>
