<?php
//---------------------------------------------------------------------------------------------------
// Proyecto: Icasus (http://wiki.us.es/icasus/)
// Archivo: lista_entidades.php
// Tipo: interfaz de usuario
// Desarrolladores: Juanan Ruiz (juanan@us.es)
//---------------------------------------------------------------------------------------------------
// Descripcion: Muestra un listado de entidades existentes y las acciones pertinentes
//---------------------------------------------------------------------------------------------------
include_once ("icasus.config.php");
include_once ("clase_base_datos.php");
include_once ("clase_ica.php");
include_once ("clase_usuario.php");

// Habilita variables de sesion
session_start();

// Comprueba si el usuario ha iniciado sesion
if (!isset($_SESSION["usuario"]))
	header ("Location: index.php?aviso=Debe iniciar sesion para acceder al sistema");

$id_usuario = $_SESSION["usuario"]->id_usuario;
$login_usuario = $_SESSION["usuario"]->login;

// Instancia los objetos que vamos a necesitar	
$base_datos = new base_datos($ic_db_host,$ic_db_login,$ic_db_clave,$ic_db_database);
$usuario = new usuario($base_datos);
$usuario->obtener_entidades($id_usuario); 
$_SESSION["usuario"]->entidades = $usuario->entidades;

/*
// Preparamos un array con la lista de entidades, se toma la lista del objeto ica si es 
// un administrador para que salgan todas, o del objeto usuario si no es administrador 
// para que solo salgan las suyas
if (isset($usuario->entidades[0])) {
	$ica = new ica($base_datos);
	$lista_entidades = $ica->listar_entidades();
	}
else 	
	$lista_entidades = $usuario->entidades;
*/

// Imprime las entidades del usuario
$lista_entidades = $usuario->entidades;

$tabla_entidades_usuario = "<table><thead><tr><th>Entidades para " . strtoupper($login_usuario) . "</th></tr></thead>\n<tbody>\n";
foreach ($lista_entidades as $entidad) {
   $tabla_entidades_usuario .= "<tr><td>" . $entidad["nombre"] . "</td>";
   $tabla_entidades_usuario .= "<td><a href=lista_indicadores.php?id_entidad=" . $entidad["id_entidad"] . ">Indicadores</a></td>" ;
   $tabla_entidades_usuario .= "<td><a href=lista_usuarios.php?id_entidad=" . $entidad["id_entidad"] . ">Usuarios</a></td>";
   $tabla_entidades_usuario .= "</tr>\n";
   }
$tabla_entidades_usuario .= "</tbody></table>\n";

//Imprime todas las entidades
$ica = new ica($base_datos);
$lista_entidades = $ica->listar_entidades();

$tabla_entidades = "<table><thead><tr><th>Todas las Entidades</th></tr></thead>\n<tbody>\n";
foreach ($lista_entidades as $entidad) {
   $tabla_entidades .= "<tr><td>" . $entidad["nombre"] . "</td>";
   $tabla_entidades .= "<td><a href=lista_indicadores.php?id_entidad=" . $entidad["id_entidad"] . ">Indicadores</a></td>" ;
   $tabla_entidades .= "<td><a href=lista_usuarios.php?id_entidad=" . $entidad["id_entidad"] . ">Usuarios</a></td>";
   $tabla_entidades .= "</tr>\n";
   }
$tabla_entidades .= "</tbody></table>\n";


//Empezamos a desplegar html
$nombre_pagina="Lista de Entidades";

//Comprobamos que el rol del usuario sea de administrador para asignarle botones de comandos avanzados
if ($usuario->entidades[0]["rol"]=="administrador") 
	$comandos = $ic_cmd_nueva_entidad . $ic_cmd_todos_usuarios ;

include_once ("inc_cabecera.php"); 
?>

<?php
print($tabla_entidades_usuario);
print($tabla_entidades); 

include_once ("inc_pie.php"); 
$base_datos->desconectar();
?>
